#define WIDTH 8
#define LINES 1
#define HEX 16
#define DEC 10
#define BIN 2

#define BLANK_SPACE 0xFF
#define MINUS 0xEF
#define DECIMAL_POINT 0xBF
#define DISPLAY_H 0x49

extern const unsigned char numbers[];
extern unsigned char display[LINES][WIDTH];

void Display_Float(float fvalue, short line, short decimalAmount);
void Display_Int(int value, short line, short base);
void LED_Init(void);
void LED_Clear(void);
void LED_Update(void);