	.module Timer.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.c
	.dbfunc e Init_Timer _Init_Timer fV
	.even
_Init_Timer::
	.dbline -1
	.dbline 9
; #include <iom168v.h>
; #include "Timer.h"
; #include "LED_Display.h"
; 
; 
; unsigned int mseccountdown1, mseccountdown2,mseccountdown3;
; 
; void Init_Timer(void)
; {
	.dbline 10
; 	mseccountdown1 = 0;
	clr R2
	clr R3
	sts _mseccountdown1+1,R3
	sts _mseccountdown1,R2
	.dbline 11
; 	mseccountdown2 = 0;
	sts _mseccountdown2+1,R3
	sts _mseccountdown2,R2
	.dbline 12
; 	mseccountdown3 = 0;
	sts _mseccountdown3+1,R3
	sts _mseccountdown3,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_Timer0 _Init_Timer0 fV
	.even
_Init_Timer0::
	.dbline -1
	.dbline 18
; }
; 
; // Timer2 is called every 1msec - used to maintain four count down 
; // software timers to control precise time delays in various routines
; void Init_Timer0(void)
; { 
	.dbline 19
; 	 TCNT0 = 0;
	clr R2
	out 0x26,R2
	.dbline 21
; 	 // Set mode 2 - reset counter on compare match, clk/256
; 	 TCCR0A = (1<<WGM01);
	ldi R24,2
	out 0x24,R24
	.dbline 22
; 	 TCCR0B = (1<<CS02);
	ldi R24,4
	out 0x25,R24
	.dbline 24
; 	 // Reset count after 1 msec
; 	 OCR0A = 78;
	ldi R24,78
	out 0x27,R24
	.dbline 26
; 	 // Enable compare match interrupt vector
; 	 TIMSK0 |= (1<<OCIE0A);
	lds R24,110
	ori R24,2
	sts 110,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 56
	jmp _TIMER0_Compare_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.c
	.dbfunc e TIMER0_Compare_Interrupt _TIMER0_Compare_Interrupt fV
	.even
_TIMER0_Compare_Interrupt::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R6
	st -y,R7
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R26
	st -y,R27
	st -y,R30
	st -y,R31
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 39
; }
; 
; #pragma interrupt_handler TIMER0_Compare_Interrupt:iv_TIMER0_COMPA
; 
; //  *******************************************************
; //                Interrupt handler
; //  *******************************************************
; 
; //  Timer0 interrupts every msec - This routines decrements 
; //  countdown timers - other routines can control timing to 
; //  within 1 msec by monitoring these software timers
; void  TIMER0_Compare_Interrupt(void)
; {
	.dbline 41
; 	//PORTD^=(1<<0);//heart beat
;  	if(mseccountdown1>0)  mseccountdown1--;
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	brne X0
	tst R3
	breq L4
X0:
	.dbline 41
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
L4:
	.dbline 42
;  	if(mseccountdown2>0)  mseccountdown2--;
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne X1
	tst R3
	breq L6
X1:
	.dbline 42
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
L6:
	.dbline 43
; 	if(mseccountdown3>0)  mseccountdown3--;
	lds R2,_mseccountdown3
	lds R3,_mseccountdown3+1
	tst R2
	brne X2
	tst R3
	breq L8
X2:
	.dbline 43
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
L8:
	.dbline 44
; 	LED_Update();//refresh the 7 segement display
	xcall _LED_Update
	.dbline -2
L3:
	.dbline 0 ; func end
	ld R0,y+
	out 0x3f,R0
	ld R31,y+
	ld R30,y+
	ld R27,y+
	ld R26,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R7,y+
	ld R6,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Timer.c
_mseccountdown3::
	.blkb 2
	.dbsym e mseccountdown3 _mseccountdown3 i
_mseccountdown2::
	.blkb 2
	.dbsym e mseccountdown2 _mseccountdown2 i
_mseccountdown1::
	.blkb 2
	.dbsym e mseccountdown1 _mseccountdown1 i
; }
