	.module TWI_slave.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.area vector(rom, abs)
	.org 96
	jmp _TWI_ISR
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
_TWI_msgSize:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.dbsym s TWI_msgSize _TWI_msgSize c
_TWI_state:
	.blkb 1
	.area idata
	.byte 248
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.dbsym s TWI_state _TWI_state c
_TWI_statusReg::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.dbstruct 0 1 .1
	.dbfield 0 lastTransOK F[0:1]
	.dbfield 0 RxDataInBuf F[1:1]
	.dbfield 0 genAddressCall F[2:1]
	.dbfield 0 unusedBits F[3:5]
	.dbend
	.dbunion 0 1 TWI_statusReg
	.dbfield 0 all c
	.dbfield 0 status S[.1]
	.dbend
	.dbsym e TWI_statusReg _TWI_statusReg S[TWI_statusReg]
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.dbfunc e TWI_Slave_Initialise _TWI_Slave_Initialise fV
; TWI_ownAddress -> R16
	.even
_TWI_Slave_Initialise::
	.dbline -1
	.dbline 51
; /*****************************************************************************
; *
; * Atmel Corporation
; *
; * File              : TWI_Slave.c
; * Compiler          : IAR EWAAVR 2.28a/3.10c
; * Revision          : $Revision: 1.7 $
; * Date              : $Date: Thursday, August 05, 2004 09:22:50 UTC $
; * Updated by        : $Author: lholsen $
; * Modified for ICCAVR: SS April 6th, 2008
; *
; * Support mail      : avr@atmel.com
; *
; * Supported devices : All devices with a TWI module can be used.
; *                     The example is written for the ATmega16
; *
; * AppNote           : AVR311 - TWI Slave Implementation
; *
; * Description       : This is sample driver to AVRs TWI module. 
; *                     It is interupt driveren. All functionality is controlled through 
; *                     passing information to and from functions. Se main.c for samples
; *                     of how to use the driver.
; *
; * These routines have be modified by SOC Robotics, Inc to remove any
; * while wait loops that may hang processor.
; *
; ****************************************************************************/
; #include <iom168v.h>
; #include "TWI_slave.h"
; 
; // Setup TWI Interrupt Service Routine
; #pragma interrupt_handler TWI_ISR:iv_TWI
; 
; static unsigned char TWI_buf[TWI_BUFFER_SIZE];     // Transceiver buffer. Set the size in the header file
; static unsigned char TWI_msgSize  = 0;             // Number of bytes to be transmitted.
; static unsigned char TWI_state    = TWI_NO_STATE;  // State byte. Default set to TWI_NO_STATE.
; 
; union TWI_statusReg TWI_statusReg = {0};           // TWI_statusReg is defined in TWI_Slave.h
; 
; /****************************************************************************
; Call this function to set up the TWI slave to its initial standby state.
; Remember to enable interrupts from the main application after initializing the 
; TWI. Pass both the slave address and the requrements for triggering on a 
; general call in the same byte. Use e.g. this notation when calling this 
; function: 
; TWI_Slave_Initialise( (TWI_slaveAddress<<TWI_ADR_BITS) | (TRUE<<TWI_GEN_BIT) );
; The TWI module is configured to NACK on any requests. Use a 
; TWI_Start_Transceiver function to start the TWI.
; ****************************************************************************/
; void TWI_Slave_Initialise(unsigned char TWI_ownAddress)
; {
	.dbline 53
;     // Set own TWI slave address. Accept TWI General Calls.
;     TWAR = TWI_ownAddress;               
	sts 186,R16
	.dbline 54
;     TWDR = 0xFF;                             // Default content = SDA released.
	ldi R24,255
	sts 187,R24
	.dbline 55
;     TWCR = (1<<TWEN)|                        // Enable TWI-interface and release TWI pins.
	ldi R24,4
	sts 188,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbsym r TWI_ownAddress 16 c
	.dbend
	.dbfunc e TWI_Transceiver_Busy _TWI_Transceiver_Busy fc
	.even
_TWI_Transceiver_Busy::
	.dbline -1
	.dbline 65
;          (0<<TWIE)|(0<<TWINT)|               // Disable TWI Interupt.
;          (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|    // Do not ACK on any requests, yet.
;          (0<<TWWC);                          //
; }    
;     
; /****************************************************************************
; Call this function to test if the TWI_ISR is busy transmitting.
; ****************************************************************************/
; unsigned char TWI_Transceiver_Busy(void)
; {
	.dbline 67
;     // IF TWI interrupt is enabled then the Transceiver is busy
;     return (TWCR&(1<<TWIE));    
	lds R16,188
	andi R16,1
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Get_State_Info _TWI_Get_State_Info fc
	.even
_TWI_Get_State_Info::
	.dbline -1
	.dbline 77
; }
; 
; /****************************************************************************
; Call this function to fetch the state information of the previous operation. 
; The function will hold execution (loop) until the TWI_ISR has completed with 
; the previous operation. If there was an error, then the function will return 
; the TWI State code. 
; ****************************************************************************/
; unsigned char TWI_Get_State_Info(void)
; {
L5:
	.dbline 79
;     // Wait until TWI has completed the transmission.
;   	while(TWI_Transceiver_Busy());             
L6:
	.dbline 79
	xcall _TWI_Transceiver_Busy
	tst R16
	brne L5
X0:
	.dbline 80
;     return (TWI_state);                         // Return error state. 
	lds R16,_TWI_state
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Start_Transceiver_With_Data _TWI_Start_Transceiver_With_Data fV
;           temp -> R10
;        msgSize -> R12
;            msg -> R14,R15
	.even
_TWI_Start_Transceiver_With_Data::
	xcall push_xgset00FC
	mov R12,R18
	movw R14,R16
	.dbline -1
	.dbline 93
; }
; 
; /****************************************************************************
; Call this function to send a prepared message, or start the Transceiver for 
; reception. Include a pointer to the data to be sent if a SLA+W is received. 
; The data will be copied to the TWI buffer. Also include how many bytes that 
; should be sent. Note that unlike the similar Master function, the Address 
; byte is not included in the message buffers. The function will hold execution 
; (loop) until the TWI_ISR has completed with the previous operation,
; then initialize the next operation and return.
; ****************************************************************************/
; void TWI_Start_Transceiver_With_Data(unsigned char *msg,unsigned char msgSize)
; {
L9:
	.dbline 96
;     unsigned char temp;
; 
;     while (TWI_Transceiver_Busy());  // Wait until TWI is ready for next transmission.
L10:
	.dbline 96
	xcall _TWI_Transceiver_Busy
	tst R16
	brne L9
X1:
	.dbline 99
; 
; 	// Number of data to transmit.
;     TWI_msgSize = msgSize;   
	sts _TWI_msgSize,R12
	.dbline 101
; 	// Copy data that may be transmitted if the TWI Master requests data.               
;     for (temp=0; temp<msgSize; temp++)      
	clr R10
	xjmp L15
L12:
	.dbline 102
;         TWI_buf[temp] = msg[temp];
	mov R30,R10
	clr R31
	add R30,R14
	adc R31,R15
	ldd R2,z+0
	ldi R24,<_TWI_buf
	ldi R25,>_TWI_buf
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
L13:
	.dbline 101
	inc R10
L15:
	.dbline 101
	cp R10,R12
	brlo L12
X2:
	.dbline 103
;     TWI_statusReg.all = 0;      
	clr R2
	sts _TWI_statusReg,R2
	.dbline 104
;     TWI_state         = TWI_NO_STATE;
	ldi R24,248
	sts _TWI_state,R24
	.dbline 105
;     TWCR = (1<<TWEN)|                      // TWI Interface enabled.
	ldi R24,197
	sts 188,R24
	.dbline -2
L8:
	.dbline 0 ; func end
	xjmp pop_xgset00FC
	.dbsym r temp 10 c
	.dbsym r msgSize 12 c
	.dbsym r msg 14 pc
	.dbend
	.dbfunc e TWI_Start_Transceiver _TWI_Start_Transceiver fV
	.even
_TWI_Start_Transceiver::
	.dbline -1
	.dbline 119
;          (1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the flag.
;          (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // Prepare to ACK next time the Slave is addressed.
;          (0<<TWWC);                        //
; }
; 
; /****************************************************************************
; Call this function to start the Transceiver without specifing new transmission 
; data. Usefull for restarting a transmission, or just starting the transceiver 
; for reception. The driver will reuse the data previously put in the transceiver 
; buffers. The function will hold execution (loop) until the TWI_ISR has completed
; with the previous operation, then initialize the next operation and return.
; ****************************************************************************/
; void TWI_Start_Transceiver(void)
; {
L17:
	.dbline 121
;     // Wait until TWI is ready for next transmission.
;     while (TWI_Transceiver_Busy());             
L18:
	.dbline 121
	xcall _TWI_Transceiver_Busy
	tst R16
	brne L17
X3:
	.dbline 122
;     TWI_statusReg.all = 0;      
	clr R2
	sts _TWI_statusReg,R2
	.dbline 123
;     TWI_state         = TWI_NO_STATE;
	ldi R24,248
	sts _TWI_state,R24
	.dbline 124
;     TWCR = (1<<TWEN)|                       // TWI Interface enabled.
	ldi R24,197
	sts 188,R24
	.dbline -2
L16:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Get_Data_From_Transceiver _TWI_Get_Data_From_Transceiver fc
;              i -> R10
;        msgSize -> R12
;            msg -> R14,R15
	.even
_TWI_Get_Data_From_Transceiver::
	xcall push_xgset00FC
	mov R12,R18
	movw R14,R16
	.dbline -1
	.dbline 141
;          (1<<TWIE)|(1<<TWINT)|              // Enable TWI Interupt and clear the flag.
;          (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|   // Prepare to ACK next time the Slave is addressed.
;          (0<<TWWC);                         //
; }
; 
; /****************************************************************************
; Call this function to read out the received data from the TWI transceiver buffer. 
; I.e. first call TWI_Start_Transceiver to get the TWI Transceiver to fetch data. 
; Then Run this function to collect the data when they have arrived. Include a 
; pointer to where to place the data and the number of bytes to fetch in the 
; function call. The function will hold execution (loop) until the TWI_ISR has 
; completed with the previous operation, before reading out the data and returning.
; If there was an error in the previous transmission the function will return the 
; TWI State code.
; ****************************************************************************/
; unsigned char TWI_Get_Data_From_Transceiver(unsigned char *msg,unsigned char msgSize)
; {
L21:
	.dbline 145
;     unsigned char i;
; 
;     // Wait until TWI is ready for next transmission.
;     while(TWI_Transceiver_Busy());             
L22:
	.dbline 145
	xcall _TWI_Transceiver_Busy
	tst R16
	brne L21
X4:
	.dbline 148
; 
; 	// Last transmission competed successfully.  
;     if(TWI_statusReg.status.lastTransOK) {
	lds R24,_TWI_statusReg
	andi R24,1
	breq L24
X5:
	.dbline 148
	.dbline 150
; 		// Copy data from Transceiver buffer.                                                              
;         for (i=0; i<msgSize; i++) {            
	clr R10
	xjmp L29
L26:
	.dbline 150
	.dbline 151
;             msg[i] = TWI_buf[i];
	ldi R24,<_TWI_buf
	ldi R25,>_TWI_buf
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	mov R30,R10
	clr R31
	add R30,R14
	adc R31,R15
	std z+0,R2
	.dbline 152
;             }
L27:
	.dbline 150
	inc R10
L29:
	.dbline 150
	cp R10,R12
	brlo L26
X6:
	.dbline 154
; 		// Slave Receive data has been read from buffer.
;         TWI_statusReg.status.RxDataInBuf = FALSE;          
	lds R24,_TWI_statusReg
	andi R24,253
	sts _TWI_statusReg,R24
	.dbline 155
;         }
L24:
	.dbline 156
;     return(TWI_statusReg.status.lastTransOK);                                   
	lds R16,_TWI_statusReg
	andi R16,1
	.dbline -2
L20:
	.dbline 0 ; func end
	xjmp pop_xgset00FC
	.dbsym r i 10 c
	.dbsym r msgSize 12 c
	.dbsym r msg 14 pc
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
L31:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
	.dbfunc e TWI_ISR _TWI_ISR fV
	.dbsym s TWI_bufPtr L31 c
	.even
_TWI_ISR::
	st -y,R2
	st -y,R3
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 166
; }
; 
; // ********** Interrupt Handlers ********** //
; /****************************************************************************
; This function is the Interrupt Service Routine (ISR), and called when the 
; TWI interrupt is triggered;that is whenever a TWI event has occurred. This 
; function should not be called directly from the main application.
; ****************************************************************************/
; void TWI_ISR(void)
; {
	.dbline 169
;     static unsigned char TWI_bufPtr;
;   
;     switch (TWSR) {
	lds R16,185
	clr R17
	cpi R16,144
	ldi R30,0
	cpc R17,R30
	brne X27
	xjmp L42
X27:
X7:
	ldi R24,144
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L46
X8:
L45:
	cpi R16,112
	ldi R30,0
	cpc R17,R30
	brne X28
	xjmp L40
X28:
X9:
	ldi R24,112
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L48
X10:
L47:
	cpi R16,0
	cpc R16,R17
	brne X29
	xjmp L44
X29:
X11:
	cpi R16,0
	ldi R30,0
	cpc R17,R30
	brge X30
	xjmp L32
X30:
X12:
L49:
	cpi R16,96
	ldi R30,0
	cpc R17,R30
	brne X31
	xjmp L41
X31:
X13:
	xjmp L32
L48:
	cpi R16,128
	ldi R30,0
	cpc R17,R30
	brne X32
	xjmp L42
X32:
X14:
	cpi R16,128
	ldi R30,0
	cpc R17,R30
	brge X33
	xjmp L32
X33:
X15:
L50:
	cpi R16,136
	ldi R30,0
	cpc R17,R30
	brne X34
	xjmp L44
X34:
X16:
	xjmp L32
L46:
	cpi R16,168
	ldi R30,0
	cpc R17,R30
	breq L35
X17:
	ldi R24,168
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L52
X18:
L51:
	cpi R16,152
	ldi R30,0
	cpc R17,R30
	brne X35
	xjmp L44
X35:
X19:
	cpi R16,152
	ldi R30,0
	cpc R17,R30
	brge X36
	xjmp L32
X36:
X20:
L53:
	cpi R16,160
	ldi R30,0
	cpc R17,R30
	brne X37
	xjmp L43
X37:
X21:
	xjmp L32
L52:
	cpi R16,192
	ldi R30,0
	cpc R17,R30
	breq L37
X22:
	ldi R24,192
	ldi R25,0
	cp R24,R16
	cpc R25,R17
	brlt L55
X23:
L54:
	cpi R16,184
	ldi R30,0
	cpc R17,R30
	breq L36
X24:
	xjmp L32
L55:
	cpi R16,200
	ldi R30,0
	cpc R17,R30
	brne X38
	xjmp L44
X38:
X25:
	xjmp L32
L35:
	.dbline 172
;        case TWI_STX_ADR_ACK:                   // Own SLA+R has been received; ACK has been returned
; //    case TWI_STX_ADR_ACK_M_ARB_LOST:         // Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
;           TWI_bufPtr   = 0;                    // Set buffer pointer to first data location
	clr R2
	sts L31,R2
L36:
	.dbline 174
;       case TWI_STX_DATA_ACK:                   // Data byte in TWDR has been transmitted; ACK has been received
;           TWDR = TWI_buf[TWI_bufPtr++];
	lds R2,L31
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts L31,R24
	ldi R24,<_TWI_buf
	ldi R25,>_TWI_buf
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 187,R2
	.dbline 175
;           TWCR = (1<<TWEN)|                    // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 179
;              (1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the flag to send byte
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // 
;              (0<<TWWC);                        //  
;           break;
	xjmp L33
L37:
	.dbline 182
;       case TWI_STX_DATA_NACK:          // Data byte in TWDR has been transmitted; NACK has been received. 
;                                        // I.e. this could be the end of the transmission.
;           if (TWI_bufPtr == TWI_msgSize) {// Have we transceived all expected data?
	lds R2,_TWI_msgSize
	lds R3,L31
	cp R3,R2
	brne L38
X26:
	.dbline 182
	.dbline 183
;               TWI_statusReg.status.lastTransOK = TRUE;  // Set status bits to completed successfully. 
	lds R24,_TWI_statusReg
	ori R24,1
	sts _TWI_statusReg,R24
	.dbline 184
;               }
	xjmp L39
L38:
	.dbline 185
; 	      else  {                        // Master has sent a NACK before all data where sent.
	.dbline 186
;               TWI_state = TWSR;                // Store TWI State as errormessage.      
	lds R2,185
	sts _TWI_state,R2
	.dbline 187
;               }        
L39:
	.dbline 189
;                                                // Put TWI Transceiver in passive mode.
;           TWCR = (1<<TWEN)|                    // Enable TWI-interface and release TWI pins
	ldi R24,4
	sts 188,R24
	.dbline 193
;              (0<<TWIE)|(0<<TWINT)|             // Disable Interupt
;              (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // Do not acknowledge on any new requests.
;              (0<<TWWC);                        //
;           break;     
	xjmp L33
L40:
	.dbline 196
;       case TWI_SRX_GEN_ACK:                // General call address has been received; ACK has been returned
; //        case TWI_SRX_GEN_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
;           TWI_statusReg.status.genAddressCall = TRUE;
	lds R24,_TWI_statusReg
	ori R24,4
	sts _TWI_statusReg,R24
L41:
	.dbline 200
;       case TWI_SRX_ADR_ACK:                     // Own SLA+W has been received ACK has been returned
; //        case TWI_SRX_ADR_ACK_M_ARB_LOST:      // Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned    
;                                                // Dont need to clear TWI_S_statusRegister.generalAddressCall due to that it is the default state.
;           TWI_statusReg.status.RxDataInBuf = TRUE;      
	lds R24,_TWI_statusReg
	ori R24,2
	sts _TWI_statusReg,R24
	.dbline 201
;           TWI_bufPtr   = 0;                    // Set buffer pointer to first data location
	clr R2
	sts L31,R2
	.dbline 203
;                                                // Reset the TWI Interupt to wait for a new event.
;           TWCR = (1<<TWEN)|                    // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 207
;              (1<<TWIE)|(1<<TWINT)|             // Enable TWI Interupt and clear the flag to send byte
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // Expect ACK on this transmission
;              (0<<TWWC);                        //      
;           break;
	xjmp L33
L42:
	.dbline 210
;       case TWI_SRX_ADR_DATA_ACK:       // Previously addressed with own SLA+W; data has been received; ACK has been returned
;       case TWI_SRX_GEN_DATA_ACK:       // Previously addressed with general call; data has been received; ACK has been returned
;           TWI_buf[TWI_bufPtr++]     = TWDR;
	lds R2,L31
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts L31,R24
	ldi R24,<_TWI_buf
	ldi R25,>_TWI_buf
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	lds R2,187
	std z+0,R2
	.dbline 211
;           TWI_statusReg.status.lastTransOK = TRUE;    // Set flag transmission successfull.       
	lds R24,_TWI_statusReg
	ori R24,1
	sts _TWI_statusReg,R24
	.dbline 213
;                                                 // Reset the TWI Interupt to wait for a new event.
;           TWCR = (1<<TWEN)|                     // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 217
;              (1<<TWIE)|(1<<TWINT)|              // Enable TWI Interrupt and clear the flag to send byte
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|   // Send ACK after next reception
;              (0<<TWWC);                         //  
;           break;
	xjmp L33
L43:
	.dbline 220
;       case TWI_SRX_STOP_RESTART:       // A STOP condition or repeated START condition has been received while still addressed as Slave    
;                                                // Put TWI Transceiver in passive mode.
;           TWCR = (1<<TWEN)|                    // Enable TWI-interface and release TWI pins
	ldi R24,4
	sts 188,R24
	.dbline 224
;              (0<<TWIE)|(0<<TWINT)|             // Disable Interrupt
;              (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|  // Do not acknowledge on any new requests.
;              (0<<TWWC);                        //
;           break;           
	xjmp L33
L44:
L32:
	.dbline 231
;       case TWI_SRX_ADR_DATA_NACK:    // Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
;       case TWI_SRX_GEN_DATA_NACK:    // Previously addressed with general call; data has been received; NOT ACK has been returned
;       case TWI_STX_DATA_ACK_LAST_BYTE: // Last data byte in TWDR has been transmitted (TWEA = 0); ACK has been received
; //    case TWI_NO_STATE              // No relevant state information available; TWINT = 0
;       case TWI_BUS_ERROR:            // Bus error due to an illegal START or STOP condition
;       default:     
;           TWI_state = TWSR;                   // Store TWI State as errormessage, operation also clears the Success bit.      
	lds R2,185
	sts _TWI_state,R2
	.dbline 232
;           TWCR = (1<<TWEN)|                   // Enable TWI-interface and release TWI pins
	ldi R24,4
	sts 188,R24
	.dbline 236
;              (0<<TWIE)|(0<<TWINT)|            // Disable Interupt
;              (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| // Do not acknowledge on any new requests.
;              (0<<TWWC);                       //
;       }
L33:
	.dbline -2
L30:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\TWI_slave.c
_TWI_buf:
	.blkb 4
	.dbsym s TWI_buf _TWI_buf A[4:4]c
; }
