	.module Board.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.c
	.dbfunc e Buttons_Init _Buttons_Init fV
	.even
_Buttons_Init::
	.dbline -1
	.dbline 7
; #include <iom168v.h>
; #include "Board.h"
; 
; unsigned char currentButtonValue;
; 
; void Buttons_Init(void)
; {
	.dbline 8
;  	 DDRD &= ~((1<<SW2) | (1<<SW3));//Ensure the button pins are inputs
	in R24,0xa
	andi R24,252
	out 0xa,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e buttonState _buttonState fc
;          value -> R20
;             sw -> R10
	.even
_buttonState::
	st -y,R10
	st -y,R20
	mov R10,R16
	.dbline -1
	.dbline 12
; }
; 
; unsigned char buttonState(unsigned char sw)
; {
	.dbline 13
;  		 unsigned char value = 0;
	clr R20
	.dbline 15
; 		 
; 		 if (!(PIND&(1<<sw)))
	ldi R16,1
	mov R17,R10
	xcall lsl8
	in R2,0x9
	and R2,R16
	brne L3
X0:
	.dbline 16
; 		 {
	.dbline 17
; 		  	value = 1;
	ldi R20,1
	.dbline 18
; 		 }
L3:
	.dbline 19
; 		 return value;
	mov R16,R20
	.dbline -2
L2:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r value 20 c
	.dbsym r sw 10 c
	.dbend
	.dbfunc e updateButtons _updateButtons fV
	.even
_updateButtons::
	.dbline -1
	.dbline 23
; }
; 
; void updateButtons(void)
; {
	.dbline 24
;  	 currentButtonValue = ( ~(PIND & ( (1<<SW2) | (1<<SW3) ) ) )&( (1<<SW2) | (1<<SW3) );
	in R24,0x9
	andi R24,3
	com R24
	andi R24,3
	sts _currentButtonValue,R24
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\Board.c
_currentButtonValue::
	.blkb 1
	.dbsym e currentButtonValue _currentButtonValue c
; }
