	.module TWI_slave.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
_TWI_msgSize:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.dbsym s TWI_msgSize _TWI_msgSize c
_TWI_state:
	.blkb 1
	.area idata
	.byte 248
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.dbsym s TWI_state _TWI_state c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.dbfunc e TWI_Slave_Initialise _TWI_Slave_Initialise fV
; TWI_ownAddress -> R10
	.even
_TWI_Slave_Initialise::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 48
; 
; /*****************************************************************************
; *
; * Atmel Corporation
; 
; * AppNote           : AVR311 - TWI Slave Implementation
; *
; * Description       : This is sample driver to AVRs TWI module. 
; *                     It is interupt driven.
; *
; ****************************************************************************/
; 
; #include <stdio.h>
; #include <iom168v.h>
; #include "TWI_slave.h"
; #include "Board.h"
; #include "Serial.h"
; 
; #include "RingBuffer.h"
;  
; static unsigned char TWI_TX_BUF[TWI_TX_BUFFER_SIZE];     // Transceiver buffer. Set the size in the header file
; //static unsigned char TWI_RX_BUF[TWI_RX_BUFFER_SIZE];     // Transceiver buffer. Set the size in the header file
; 
; static unsigned char TWI_msgSize  = 0;             // Number of bytes to be transmitted.
; static unsigned char TWI_state    = TWI_NO_STATE;  // State byte. Default set to TWI_NO_STATE.
; 
; unsigned char temp;//=>Billy Try to remove
; 
; unsigned char busyTx, busyRx, newData;
; 
; unsigned char text[15];
; 
; 
; RingBuff_t Rx_Buffer;
; 
; char * Print_Int(int intvalue, char *text, unsigned char base);
; 
; /****************************************************************************
; Call this function to set up the TWI slave to its initial standby state.
; Remember to enable interrupts from the main application after initializing the TWI.
; Pass both the slave address and the requrements for triggering on a general call in the
; same byte. Use e.g. this notation when calling this function:
; TWI_Slave_Initialise( (TWI_slaveAddress<<TWI_ADR_BITS) | (TRUE<<TWI_GEN_BIT) );
; The TWI module is configured to NACK on any requests. Use a TWI_Start_Transceiver function to 
; start the TWI.
; ****************************************************************************/
; void TWI_Slave_Initialise( unsigned char TWI_ownAddress )
; {
	.dbline 50
;    
;   Buffer_Initialize(&Rx_Buffer);
	ldi R16,<_Rx_Buffer
	ldi R17,>_Rx_Buffer
	xcall _Buffer_Initialize
	.dbline 52
;   
;   busyTx = 0;
	clr R2
	sts _busyTx,R2
	.dbline 53
;   busyRx = 0;
	sts _busyRx,R2
	.dbline 54
;   newData = 0;
	sts _newData,R2
	.dbline 56
; 
;   TWAR = (TWI_ownAddress<<1) | 0  ;             // Set own TWI slave address. Do not accept TWI General Calls.
	mov R2,R10
	lsl R2
	sts 186,R2
	.dbline 61
;   
;   //if you want to answer any address
;   //TWAMR = 0xFF;
;   
;   TWDR = 0xFF;                                  // Default content = SDA released.
	ldi R24,255
	sts 187,R24
	.dbline 63
;   
;   TWI_state         = TWI_NO_STATE ;
	ldi R24,248
	sts _TWI_state,R24
	.dbline 65
;   
;   TWCR = (1<<TWEN)|                             // TWI Interface enabled.
	ldi R24,197
	sts 188,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r TWI_ownAddress 10 c
	.dbend
	.dbfunc e TWI_Get_State_Info _TWI_Get_State_Info fc
	.even
_TWI_Get_State_Info::
	.dbline -1
	.dbline 94
;          (1<<TWIE)|(1<<TWINT)|                  // Enable TWI Interupt and clear the flag.
;          (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|       // Prepare to ACK next time the Slave is addressed.
;          (0<<TWWC);
;   
; 
; }    
;     
; /****************************************************************************
; Call this function to test if the TWI_ISR is busy transmitting.
; ****************************************************************************/
; 
; /*
; unsigned char TWI_Transceiver_Busy( void )
; {
; 
;   return busy;
;  // return ( TWCR & (1<<TWIE) );                  // IF TWI interrupt is enabled then the Transceiver is busy
; }
; 
; */
; 
; 
; /****************************************************************************
; Call this function to fetch the state information of the previous operation. The function will hold execution (loop)
; until the TWI_ISR has completed with the previous operation. If there was an error, then the function 
; will return the TWI State code. 
; ****************************************************************************/
; unsigned char TWI_Get_State_Info( void )
; {
	.dbline 96
;   //while ( TWI_Transceiver_Busy() );             // Wait until TWI has completed the transmission.
;   return ( TWI_state );                         // Return error state. 
	lds R16,_TWI_state
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Transceiver_Update_Data _TWI_Transceiver_Update_Data fV
;      temp_SREG -> R10
;           temp -> R12
;        msgSize -> R18
;            msg -> R16,R17
	.even
_TWI_Transceiver_Update_Data::
	st -y,R10
	st -y,R12
	.dbline -1
	.dbline 108
; }
; 
; /****************************************************************************
; Call this function to send a prepared message, or start the Transceiver for reception. Include
; a pointer to the data to be sent if a SLA+W is received. The data will be copied to the TWI buffer. 
; Also include how many bytes that should be sent. Note that unlike the similar Master function, the
; Address byte is not included in the message buffers.
; The function will hold execution (loop) until the TWI_ISR has completed with the previous operation,
; then initialize the next operation and return.
; ****************************************************************************/
; void TWI_Transceiver_Update_Data( unsigned char *msg, unsigned char msgSize )
; {
L5:
	.dbline 112
;   	unsigned char temp;
; 	unsigned char temp_SREG;
; 
;   	while ( busyTx ); // Wait until TWI is finished transmitting the current data if it is in the middle of doing so.
L6:
	.dbline 112
	lds R2,_busyTx
	tst R2
	brne L5
X0:
	.dbline 115
;  
;     //Ensure this is run as an atomic block
;     temp_SREG = SREG;//Save the current state of the Global Interrupt bit
	in R10,0x3f
	.dbline 116
;     CLI();//Disable global interrupts
	cli
	.dbline 118
;   
;   	if (msgSize <= TWI_TX_BUFFER_SIZE)
	ldi R24,20
	cp R24,R18
	brlo L8
X1:
	.dbline 119
;   	{
	.dbline 120
;    	 	TWI_msgSize = msgSize;                        // Number of data to transmit.
	sts _TWI_msgSize,R18
	.dbline 121
;   	}
	xjmp L9
L8:
	.dbline 123
;   	else
;   	{
	.dbline 124
;    		TWI_msgSize = TWI_TX_BUFFER_SIZE;			   //Only copy what we can
	ldi R24,20
	sts _TWI_msgSize,R24
	.dbline 125
;   	}
L9:
	.dbline 128
;   
;   
;   	for ( temp = 0; temp < TWI_msgSize; temp++ )      // Copy data that may be transmitted if the TWI Master requests data.
	clr R12
	xjmp L13
L10:
	.dbline 129
;     {
	.dbline 130
;     	TWI_TX_BUF[ temp ] = msg[ temp ];
	mov R30,R12
	clr R31
	add R30,R16
	adc R31,R17
	ldd R2,z+0
	ldi R24,<_TWI_TX_BUF
	ldi R25,>_TWI_TX_BUF
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 131
;     }
L11:
	.dbline 128
	inc R12
L13:
	.dbline 128
	lds R2,_TWI_msgSize
	cp R12,R2
	brlo L10
X2:
	.dbline 134
;         
; 	//Restore the Global Interrupts if enabled
;     SREG = temp_SREG;
	out 0x3f,R10
	.dbline -2
L4:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r temp_SREG 10 c
	.dbsym r temp 12 c
	.dbsym r msgSize 18 c
	.dbsym r msg 16 pc
	.dbend
	.dbfunc e TWI_Get_Data_From_Transceiver _TWI_Get_Data_From_Transceiver fc
;      temp_SREG -> R10
;              i -> R20
;        msgSize -> R12
;            msg -> R14,R15
	.even
_TWI_Get_Data_From_Transceiver::
	xcall push_xgset30FC
	mov R12,R18
	movw R14,R16
	.dbline -1
	.dbline 147
; }
; 
; 
; /****************************************************************************
; Call this function to read out the received data from the TWI transceiver buffer. I.e. first call
; TWI_Start_Transceiver to get the TWI Transceiver to fetch data. Then Run this function to collect the
; data when they have arrived. Include a pointer to where to place the data and the number of bytes
; to fetch in the function call. The function will hold execution (loop) until the TWI_ISR has completed 
; with the previous operation, before reading out the data and returning.
; If there was an error in the previous transmission the function will return the TWI State code.
; ****************************************************************************/
; unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
; {
	.dbline 148
; 	unsigned char i = 0;
	clr R20
L15:
	.dbline 151
;     unsigned char temp_SREG;
; 
;   	while ( busyRx );             // Wait until TWI is ready for next transmission.
L16:
	.dbline 151
	lds R2,_busyRx
	tst R2
	brne L15
X3:
	.dbline 154
;  	
;     //Ensure this is run as an atomic block
;     temp_SREG = SREG;//Save the current state of the Global Interrupt bit
	in R10,0x3f
	.dbline 155
;     CLI();//Disable global interrupts
	cli
	xjmp L19
L18:
	.dbline 158
; 	
;     while(Rx_Buffer.Elements && i < msgSize)
;     {
	.dbline 159
;     	msg[ i++ ] = Buffer_GetElement(&Rx_Buffer);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	ldi R16,<_Rx_Buffer
	ldi R17,>_Rx_Buffer
	push R2
	push R3
	xcall _Buffer_GetElement
	pop R3
	pop R2
	mov R30,R2
	clr R31
	add R30,R14
	adc R31,R15
	std z+0,R16
	.dbline 160
;     }
L19:
	.dbline 157
	lds R2,_Rx_Buffer+36
	tst R2
	breq L22
X4:
	cp R20,R12
	brlo L18
X5:
L22:
	.dbline 164
;     
;     
;     //Restore the Global Interrupts if enabled
;     SREG = temp_SREG;
	out 0x3f,R10
	.dbline 166
;     
;     return i;
	mov R16,R20
	.dbline -2
L14:
	.dbline 0 ; func end
	xjmp pop_xgset30FC
	.dbsym r temp_SREG 10 c
	.dbsym r i 20 c
	.dbsym r msgSize 12 c
	.dbsym r msg 14 pc
	.dbend
	.area vector(rom, abs)
	.org 96
	jmp _TWI_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
L24:
	.blkb 2
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.dbfunc e TWI_Interrupt _TWI_Interrupt fV
	.dbsym s TWI_bufPtr L24 S
	.even
_TWI_Interrupt::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R6
	st -y,R7
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R20
	st -y,R21
	st -y,R24
	st -y,R25
	st -y,R26
	st -y,R27
	st -y,R30
	st -y,R31
	in R0,0x3f
	st -y,R0
	st -y,R20
	st -y,R21
	sbiw R28,1
	.dbline -1
	.dbline 197
;   
;  // if( newData )               // Last transmission competed successfully.              
;   //{
;  //   newData = 0;
; //    if (msgSize > TWI_RX_BUFFER_SIZE)//if we want to read more data then we can handle
; //	{  			  			      //cap it to our buffer size
; //	   msgSize = TWI_RX_BUFFER_SIZE;
; //	} 
; 	                                          
; //    for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
; //    {
; //      msg[ i ] = TWI_RX_BUF[ i ];
;  //   }
;     
; 	//return 1;
;  // }
;  // else
; //  {
;  //  	  return 0;
;  // }                                 
; }
; 
; // ********** Interrupt Handlers ********** //
; /****************************************************************************
; This function is the Interrupt Service Routine (ISR), and called when the TWI interrupt is triggered;
; that is whenever a TWI event has occurred. This function should not be called directly from the main
; application.
; ****************************************************************************/
; #pragma interrupt_handler TWI_Interrupt:iv_TWI
; void  TWI_Interrupt(void)
; {
	.dbline 200
;   static short TWI_bufPtr;
;   
;   TWI_state = TWSR;//so I know what my last state was (for dubug)
	lds R2,185
	sts _TWI_state,R2
	.dbline 202
; 
;   switch (TWSR)
	lds R20,185
	clr R21
	cpi R20,144
	ldi R30,0
	cpc R21,R30
	brne X26
	xjmp L34
X26:
X6:
	ldi R24,144
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L41
X7:
L40:
	cpi R20,112
	ldi R30,0
	cpc R21,R30
	brne X27
	xjmp L33
X27:
X8:
	ldi R24,112
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L43
X9:
L42:
	cpi R20,0
	cpc R20,R21
	brne X28
	xjmp L37
X28:
X10:
	cpi R20,0
	ldi R30,0
	cpc R21,R30
	brge X29
	xjmp L25
X29:
X11:
L44:
	cpi R20,96
	ldi R30,0
	cpc R21,R30
	brne X30
	xjmp L33
X30:
X12:
	xjmp L25
L43:
	cpi R20,128
	ldi R30,0
	cpc R21,R30
	brne X31
	xjmp L34
X31:
X13:
	cpi R20,128
	ldi R30,0
	cpc R21,R30
	brge X32
	xjmp L25
X32:
X14:
L45:
	cpi R20,136
	ldi R30,0
	cpc R21,R30
	brne X33
	xjmp L36
X33:
X15:
	xjmp L25
L41:
	cpi R20,168
	ldi R30,0
	cpc R21,R30
	breq L28
X16:
	ldi R24,168
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L47
X17:
L46:
	cpi R20,152
	ldi R30,0
	cpc R21,R30
	brne X34
	xjmp L36
X34:
X18:
	cpi R20,152
	ldi R30,0
	cpc R21,R30
	brge X35
	xjmp L25
X35:
X19:
L48:
	cpi R20,160
	ldi R30,0
	cpc R21,R30
	brne X36
	xjmp L35
X36:
X20:
	xjmp L25
L47:
	cpi R20,192
	ldi R30,0
	cpc R21,R30
	brne X37
	xjmp L32
X37:
X21:
	ldi R24,192
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L50
X22:
L49:
	cpi R20,184
	ldi R30,0
	cpc R21,R30
	breq L29
X23:
	xjmp L25
L50:
	cpi R20,200
	ldi R30,0
	cpc R21,R30
	brne X38
	xjmp L37
X38:
X24:
	xjmp L25
L28:
	.dbline 206
;   {
;     case TWI_STX_ADR_ACK: // Own SLA+R has been received; ACK has been returned
; //    case TWI_STX_ADR_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
;       TWI_bufPtr   = 0; // Set buffer pointer to first data location
	clr R2
	clr R3
	sts L24+1,R3
	sts L24,R2
	.dbline 207
;       busyTx = 1; //This flag says that data is currently being read by the master 
	ldi R24,1
	sts _busyTx,R24
L29:
	.dbline 211
; 	case TWI_STX_DATA_ACK: // Data byte in TWDR has been transmitted; ACK has been received
;  
; 	  
; 	  if (TWI_bufPtr < TWI_TX_BUFFER_SIZE)
	lds R24,L24
	lds R25,L24+1
	cpi R24,20
	ldi R30,0
	cpc R25,R30
	brge L30
X25:
	.dbline 212
; 	  {
	.dbline 213
; 	   	 TWDR = TWI_TX_BUF[TWI_bufPtr++];
	movw R2,R24
	adiw R24,1
	sts L24+1,R25
	sts L24,R24
	ldi R24,<_TWI_TX_BUF
	ldi R25,>_TWI_TX_BUF
	movw R30,R2
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 187,R2
	.dbline 214
; 	  }
	xjmp L31
L30:
	.dbline 216
; 	  else
; 	  {
	.dbline 217
; 	   	 TWDR = 0xFF;//no valid data to send 
	ldi R24,255
	sts 187,R24
	.dbline 218
; 	  }
L31:
	.dbline 221
; 	  
; 	  
;       TWCR = (1<<TWEN)|                         // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 225
;              (1<<TWIE)|(1<<TWINT)|              // Enable TWI Interupt and clear the flag to the send byte
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|   // Expect an acknowlege for the byte 
;              (0<<TWWC);                         //  
;       break;
	xjmp L26
L32:
	.dbline 231
; 	  
;     case TWI_STX_DATA_NACK: // Data byte in TWDR has been transmitted; NACK has been received. 
;                             // I.e. the end of the transmission.
; 
; 									 
; 	  busyTx = 0;	// We are no longer being read by the master						 
	clr R2
	sts _busyTx,R2
	.dbline 233
; 									 
;       TWCR = (1<<TWEN)|                          // Enable TWI-interface
	ldi R24,197
	sts 188,R24
	.dbline 237
;              (1<<TWIE)|(1<<TWINT)|               // Enable Interupt and clear the interrupt
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|    // Acknowledge any new requests.
;              (0<<TWWC);                          
;       break;
	xjmp L26
L33:
	.dbline 247
; 	  
; 	  
;     case TWI_SRX_GEN_ACK:            // General call address has been received; ACK has been returned
; //    case TWI_SRX_GEN_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
; 
;     case TWI_SRX_ADR_ACK:            // Own SLA+W has been received ACK has been returned
; //    case TWI_SRX_ADR_ACK_M_ARB_LOST: // Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned    
;                                                         // Dont need to clear TWI_S_statusRegister.generalAddressCall due to that it is the default state.
;      
; 	  busyRx = 1;	// Flag to show that the master is writing to us
	ldi R24,1
	sts _busyRx,R24
	.dbline 251
; 	        
;     //  TWI_bufPtr   = 0;                           // Set buffer pointer to first data location
;                                                   
;       TWCR = (1<<TWEN)|                           // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 255
;              (1<<TWIE)|(1<<TWINT)|                // Enable TWI Interupt and clear the flag to send byte
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|     // ACK data
;              (0<<TWWC);                           //      
;       break;
	xjmp L26
L34:
	.dbline 260
;     case TWI_SRX_ADR_DATA_ACK:       // Previously addressed with own SLA+W; data has been received; ACK has been returned
;     case TWI_SRX_GEN_DATA_ACK:       // Previously addressed with general call; data has been received; ACK has been returned
;     
;     
;     Buffer_StoreElement( &Rx_Buffer, TWDR);   
	lds R18,187
	ldi R16,<_Rx_Buffer
	ldi R17,>_Rx_Buffer
	xcall _Buffer_StoreElement
	.dbline 273
; 	//  newData = 1; //Flag to say we have new data
; 	  
; 	  //Ensure that our buffer has enough room for the data
; 	//  if (TWI_bufPtr < TWI_RX_BUFFER_SIZE)
; 	//  {
; 	 //  	 TWI_RX_BUF[TWI_bufPtr++] = TWDR;
; 	 // }
; 	 // else
; 	 // {
; 		// temp = TWDR;//read in the unused data
; 	  //}                      
;                                                         
;       TWCR = (1<<TWEN)|                             // TWI Interface enabled
	ldi R24,197
	sts 188,R24
	.dbline 277
;              (1<<TWIE)|(1<<TWINT)|                  // Enable TWI Interupt and clear the flag
;              (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|       // Send ACK after next reception
;              (0<<TWWC);                             //  
;       break;
	xjmp L26
L35:
	.dbline 279
;     case TWI_SRX_STOP_RESTART:       // A STOP condition or repeated START condition has been received while still addressed as Slave    
; 		busyRx = 0;
	clr R2
	sts _busyRx,R2
	.dbline 282
; 	 
; 	                                     
;       	TWCR = 	(1<<TWEN)|                              // Enable TWI-interface and release TWI pins
	ldi R24,197
	sts 188,R24
	.dbline 286
;              	(1<<TWIE)|(1<<TWINT)|                   // Enable Interupt
;              	(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|        // Acknowledge any new requests.
;              	(0<<TWWC); 
; 	  	break;
	xjmp L26
L36:
	.dbline 292
; 	            
;     case TWI_SRX_ADR_DATA_NACK:      // Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
;     case TWI_SRX_GEN_DATA_NACK:      // Previously addressed with general call; data has been received; NOT ACK has been returned
;     
;     //Ignore the data
; 	temp = TWDR;
	lds R2,187
	sts _temp,R2
L37:
L25:
	.dbline 298
; 
;     case TWI_STX_DATA_ACK_LAST_BYTE: // Last data byte in TWDR has been transmitted (TWEA = 0); ACK has been received
; //    case TWI_NO_STATE              // No relevant state information available; TWINT = 0
;     case TWI_BUS_ERROR:         // Bus error due to an illegal START or STOP condition
;     default:     
;       TWI_state = TWSR;                                 // Store TWI State as errormessage, operation also clears the Success bit.      
	lds R2,185
	sts _TWI_state,R2
	.dbline 299
;       uart0_puts ("Error\n");
	ldi R16,<L38
	ldi R17,>L38
	xcall _uart0_puts
	.dbline 300
; 	  Print_Int(TWI_state,text,16);
	ldi R24,16
	std y+0,R24
	ldi R18,<_text
	ldi R19,>_text
	lds R16,_TWI_state
	clr R17
	xcall _Print_Int
	.dbline 301
; 	  uart0_puts (text);
	ldi R16,<_text
	ldi R17,>_text
	xcall _uart0_puts
	.dbline 302
; 	  uart0_puts ("\nHave a nice day");
	ldi R16,<L39
	ldi R17,>L39
	xcall _uart0_puts
	.dbline 304
; 	  	 
; 	  TWCR = (1<<TWEN)|                                 // Enable TWI-interface and release TWI pins
	ldi R24,213
	sts 188,R24
	.dbline 308
;              (1<<TWIE)|(1<<TWINT)|                      // Ensable Interupt
;              (1<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|           // Acknewlege any new requests. Release the SDA SCL lines
;              (0<<TWWC);                                 //
;   }
L26:
	.dbline -2
L23:
	.dbline 0 ; func end
	adiw R28,1
	ld R21,y+
	ld R20,y+
	ld R0,y+
	out 0x3f,R0
	ld R31,y+
	ld R30,y+
	ld R27,y+
	ld R26,y+
	ld R25,y+
	ld R24,y+
	ld R21,y+
	ld R20,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R7,y+
	ld R6,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	reti
	.dbend
	.area lit(rom, con, rel)
L52:
	.byte 48,49
	.byte 50,51
	.byte 52,53
	.byte 54,55
	.byte 56,57
	.byte 'A,'B
	.byte 'C,'D
	.byte 'E,'F
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
	.dbfunc e Print_Int _Print_Int fpc
;      myLetters -> y+0
;           temp -> R12
;          start -> R22,R23
;          count -> R20,R21
;           base -> R14
;           text -> R10,R11
;       intvalue -> y+26
	.even
_Print_Int::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,16
	ldd R14,y+30
	.dbline -1
	.dbline 313
; }
; 
; 
; char * Print_Int(int intvalue, char *text, unsigned char base)
; {
	.dbline 314
; 	 char myLetters[] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
	ldi R24,<L52
	ldi R25,>L52
	movw R30,R28
	ldi R16,16
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	.dbline 315
; 	 int start=0, count = 0;
	clr R22
	clr R23
	.dbline 315
	clr R20
	clr R21
	.dbline 318
; 	 unsigned char temp;
; 	 
; 	 if (base == 10)
	mov R24,R14
	cpi R24,10
	brne L53
X39:
	.dbline 319
; 	 {
	.dbline 320
; 		 if(intvalue < 0)
	ldd R24,y+26
	ldd R25,y+27
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt X46
	xjmp L54
X46:
X40:
	.dbline 321
; 		 {	 
	.dbline 322
; 			text[count++] = '-';
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R2
	add R30,R10
	adc R31,R11
	ldi R24,45
	std z+0,R24
	.dbline 323
; 			intvalue = -intvalue;
	ldd R24,y+26
	ldd R25,y+27
	com R24
	com R25
	subi R24,0xFF
	sbci R25,0xFF
	std y+27,R25
	std y+26,R24
	.dbline 324
; 			start++;
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 325
; 		 } 
	.dbline 326
; 	 }else if (base == 16)
	xjmp L54
L53:
	.dbline 326
	mov R24,R14
	cpi R24,16
	brne L57
X41:
	.dbline 327
; 	 {	 
	.dbline 328
; 		text[count++] = '0';
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R2
	add R30,R10
	adc R31,R11
	ldi R24,48
	std z+0,R24
	.dbline 329
; 		text[count++] = 'X';
	movw R12,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldi R24,88
	std z+0,R24
	.dbline 330
; 		start+=2;	 
	subi R22,254  ; offset = 2
	sbci R23,255
	.dbline 331
; 	 } else if (base == 8)
	xjmp L58
L57:
	.dbline 331
	mov R24,R14
	cpi R24,8
	brne L59
X42:
	.dbline 332
; 	 {	 
	.dbline 333
; 		text[count++] = '0';
	movw R12,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldi R24,48
	std z+0,R24
	.dbline 334
; 		text[count++] = 'O';
	movw R12,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldi R24,79
	std z+0,R24
	.dbline 335
; 		start+=2;	 
	subi R22,254  ; offset = 2
	sbci R23,255
	.dbline 336
; 	 } else if (base == 2)
	xjmp L60
L59:
	.dbline 336
	mov R24,R14
	cpi R24,2
	brne L61
X43:
	.dbline 337
; 	 {	 
	.dbline 338
; 		text[count++] = '0';
	movw R12,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldi R24,48
	std z+0,R24
	.dbline 339
; 		text[count++] = 'B';
	movw R12,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R30,R12
	add R30,R10
	adc R31,R11
	ldi R24,66
	std z+0,R24
	.dbline 340
; 		start+=2;	 
	subi R22,254  ; offset = 2
	sbci R23,255
	.dbline 341
; 	 } 
L61:
L60:
L58:
L54:
L63:
	.dbline 344
; 	 
; 	 //find the digits
; 	 do {
	.dbline 345
; 	 	text[count++] = myLetters[intvalue % base];
	movw R12,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	mov R18,R14
	clr R19
	ldd R16,y+26
	ldd R17,y+27
	xcall mod16s
	movw R30,R16
	movw R24,R28
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	movw R30,R12
	add R30,R10
	adc R31,R11
	std z+0,R2
	.dbline 346
; 	 } while ((intvalue /= base) > 0);
L64:
	.dbline 346
	mov R18,R14
	clr R19
	ldd R16,y+26
	ldd R17,y+27
	xcall div16s
	movw R12,R16
	std y+27,R13
	std y+26,R12
	clr R2
	clr R3
	cp R2,R16
	cpc R3,R17
	brlt L63
X44:
	.dbline 348
; 	 
; 	 text[count--] = 0x00;
	movw R12,R20
	subi R20,1
	sbci R21,0
	movw R30,R12
	add R30,R10
	adc R31,R11
	std z+0,R2
	xjmp L67
L66:
	.dbline 352
; 	 
; 	 //reverse to correct order
; 	 while (start < count)
; 	 {
	.dbline 353
; 		 temp = text[start];
	movw R30,R22
	add R30,R10
	adc R31,R11
	ldd R12,z+0
	.dbline 354
; 		 text[start] = text[count];
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	movw R30,R22
	add R30,R10
	adc R31,R11
	std z+0,R2
	.dbline 355
; 		 text[count] = temp;
	movw R30,R20
	add R30,R10
	adc R31,R11
	std z+0,R12
	.dbline 356
; 		 start++;
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 357
; 		 count--; 
	subi R20,1
	sbci R21,0
	.dbline 358
; 	 }
L67:
	.dbline 351
	cp R22,R20
	cpc R23,R21
	brlt L66
X45:
	.dbline 360
; 	 
; 	 return text;
	movw R16,R10
	.dbline -2
L51:
	.dbline 0 ; func end
	adiw R28,16
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l myLetters 0 A[16:16]c
	.dbsym r temp 12 c
	.dbsym r start 22 I
	.dbsym r count 20 I
	.dbsym r base 14 c
	.dbsym r text 10 pc
	.dbsym l intvalue 26 I
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
_Rx_Buffer::
	.blkb 37
	.dbstruct 0 37 .1
	.dbfield 0 Buffer A[32:32]c
	.dbfield 32 InPtr pc
	.dbfield 34 OutPtr pc
	.dbfield 36 Elements c
	.dbend
	.dbsym e Rx_Buffer _Rx_Buffer S[.1]
_text::
	.blkb 15
	.dbsym e text _text A[15:15]c
_newData::
	.blkb 1
	.dbsym e newData _newData c
_busyRx::
	.blkb 1
	.dbsym e busyRx _busyRx c
_busyTx::
	.blkb 1
	.dbsym e busyTx _busyTx c
_temp::
	.blkb 1
	.dbsym e temp _temp c
_TWI_TX_BUF:
	.blkb 20
	.dbsym s TWI_TX_BUF _TWI_TX_BUF A[20:20]c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
L39:
	.blkb 17
	.area idata
	.byte 10,'H,'a,'v,'e,32,'a,32,'n,'i,'c,'e,32,'d,'a,'y
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
L38:
	.blkb 7
	.area idata
	.byte 'E,'r,'r,'o,'r,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\TWI_slave.c
; 	 
; }
