	.module LED8_ISRs.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_ISRs.c
	.area vector(rom, abs)
	.org 56
	jmp _TIMER0_Compare_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_ISRs.c
	.dbfunc e UART_RX_Interrupt _UART_RX_Interrupt fV
;        tmphead -> R18
;           data -> R16
	.even
_UART_RX_Interrupt::
	.dbline -1
	.dbline 85
; /**************************************************************
; 
;    Program Title:  Led8 Controller
;    
;    Program Name:  LED8_ISRs.c		  Version: 0.85
;    
;    Author:  SS	  					  Date:  August 10, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.13A
;    
;    This file contains routines that implement the interrupt service routines 
;    for the Wasp Monitor.
;    
;    Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom48v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "LED8_Uart.h"
; #include "LED8_Defines.h"
; #include "LED8_Extern.h"
; 
; // Vector numbers for ATmega16
; //#pragma interrupt_handler UART_RX_Interrupt:12 UART_TX_Interrupt:13
; // Vector numbers for ATmega32
; //#pragma interrupt_handler UART_RX_Interrupt:14 UART_TX_Interrupt:16
; #pragma interrupt_handler TIMER0_Compare_Interrupt:iv_TIMER0_COMPA
; //#pragma interrupt_handler TIMER0_Compare_Interrupt:17
; //#pragma interrupt_handler TIMER2_Compare_Interrupt:iv_TIMER2_COMPA
; 
; //*********************************************************
; //*********************************************************
; //     Interrupt handlers
; //*********************************************************
; //*********************************************************
; 
; //  USART serial receiver interrupt handler
; //  Flow control by XON/XOFF
; void UART_RX_Interrupt(void)
; {
	.dbline 88
; 	unsigned char data,tmphead;
; 	
; 	data = UCSR0A;
	lds R16,192
	.dbline 89
; 	if((data&0x10)) frameerror = YES;
	sbrs R16,4
	rjmp L2
X0:
	.dbline 89
	ldi R24,1
	sts _frameerror,R24
L2:
	.dbline 90
; 	if((data&0x08)) dataoverrun = YES;
	sbrs R16,3
	rjmp L4
X1:
	.dbline 90
	ldi R24,1
	sts _dataoverrun,R24
L4:
	.dbline 92
; 	
; 	data = UDR0;   // read the received data
	lds R16,198
	.dbline 94
; 	
; 	tmphead = (UART_RxHead+1)&UART_RX_BUFFER_MASK;  // calculate buffer index
	lds R18,_UART_RxHead
	subi R18,255    ; addi 1
	andi R18,63
	.dbline 95
; 	UART_RxHead = tmphead;      // store new index
	sts _UART_RxHead,R18
	.dbline 96
; 	UART_RxBuf[tmphead] = data; // store received data in buffer
	ldi R24,<_UART_RxBuf
	ldi R25,>_UART_RxBuf
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 98
; 	
; 	rxcnt++;
	lds R24,_rxcnt
	subi R24,255    ; addi 1
	sts _rxcnt,R24
	.dbline 99
; 	if(rxcnt>UART_RX_BUFFER_SIZE-1) rxcnt = UART_RX_BUFFER_SIZE-2;
	ldi R24,63
	lds R2,_rxcnt
	cp R24,R2
	brsh L6
X2:
	.dbline 99
	ldi R24,62
	sts _rxcnt,R24
L6:
	.dbline 104
; 	
; 
; 	// If receive buffer almost full Fire TX interrupt if 
; 	// transmit buffer empty otherwise alert Tx int routine XOFF must go
; 	if((rxcnt>(UART_RX_BUFFER_SIZE-30))&&(xoffsent==NO))  {
	ldi R24,34
	lds R2,_rxcnt
	cp R24,R2
	brsh L8
X3:
	lds R2,_xoffsent
	tst R2
	brne L8
X4:
	.dbline 104
	.dbline 105
; 	    if((UCSR0A&0x20))  UCSR0B |= (1<<UDRIE0);
	lds R2,192
	sbrs R2,5
	rjmp L10
X5:
	.dbline 105
	lds R24,193
	ori R24,32
	sts 193,R24
	xjmp L11
L10:
	.dbline 106
; 		else sendxoff = YES;
	ldi R24,1
	sts _sendxoff,R24
L11:
	.dbline 107
; 		}
L8:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r tmphead 18 c
	.dbsym r data 16 c
	.dbend
	.dbfunc e UART_TX_Interrupt _UART_TX_Interrupt fV
;        tmptail -> R16
	.even
_UART_TX_Interrupt::
	.dbline -1
	.dbline 121
; 	
; //	if((rxcnt>(UART_RX_BUFFER_SIZE-10))&&(xoffsent==NO)&&(enablexonoff==YES)) {
; //	if((rxcnt>(UART_RX_BUFFER_SIZE-10))&&(xoffsent==NO)) {
; 	// If tx buffer is empty then transmit xoff else signal tx to send xoff
; //	    sendxonxoff = YES;
; //		xoffsent = YES;
; //		UCSRB |= (1<<UDRIE);  // Fire TX interrupt	
; //		}
; }
; 
; //  UART transmit interrupt handler
; //  Flow control by XON/XOFF
; void UART_TX_Interrupt(void)
; {
	.dbline 125
; 	unsigned char tmptail;
; 
; 	// Check if all data has been transmitted
; 	if(UART_TxHead != UART_TxTail)  {
	lds R2,_UART_TxTail
	lds R3,_UART_TxHead
	cp R3,R2
	brne X16
	xjmp L13
X16:
X6:
	.dbline 125
	.dbline 127
; 	    // Check chars in rx buffer - if too many - transmit XOFF
; 		if((rxcnt>(UART_RX_BUFFER_SIZE-34))&&((xoffsent==NO)||(sendxoff==YES))){
	ldi R24,30
	lds R2,_rxcnt
	cp R24,R2
	brsh L15
X7:
	lds R2,_xoffsent
	tst R2
	breq L17
X8:
	lds R24,_sendxoff
	cpi R24,1
	brne L15
X9:
L17:
	.dbline 127
	.dbline 128
; 		    UDR0 = XOFF;
	ldi R24,19
	sts 198,R24
	.dbline 129
; 			xoffcnt++;
	lds R24,_xoffcnt
	lds R25,_xoffcnt+1
	adiw R24,1
	sts _xoffcnt+1,R25
	sts _xoffcnt,R24
	.dbline 130
; 			xoffsent = YES;
	ldi R24,1
	sts _xoffsent,R24
	.dbline 131
; 			sendxoff = NO;
	clr R2
	sts _sendxoff,R2
	.dbline 132
; 			}
	xjmp L14
L15:
	.dbline 133
; 		else if((rxcnt<5)&&(xoffsent==YES)) {
	lds R24,_rxcnt
	cpi R24,5
	brsh L18
X10:
	lds R24,_xoffsent
	cpi R24,1
	brne L18
X11:
	.dbline 133
	.dbline 134
; 		    UDR0 = XON;
	ldi R24,17
	sts 198,R24
	.dbline 135
; 			xoncnt++;
	lds R24,_xoncnt
	lds R25,_xoncnt+1
	adiw R24,1
	sts _xoncnt+1,R25
	sts _xoncnt,R24
	.dbline 136
; 			xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 137
; 		    }
	xjmp L14
L18:
	.dbline 138
; 		else {
	.dbline 140
; 			 // Calculate buffer index
; 			 tmptail = (UART_TxTail + 1) & UART_TX_BUFFER_MASK;
	lds R16,_UART_TxTail
	subi R16,255    ; addi 1
	andi R16,63
	.dbline 141
; 			 UART_TxTail = tmptail;     // Store new index
	sts _UART_TxTail,R16
	.dbline 142
; 			 UDR0 = UART_TxBuf[tmptail]; // Start transmission
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 198,R2
	.dbline 147
; //			 if(UART_TxBuf[tmptail]==XON) {
; //			 	  xoffsent = NO;
; //				  xonsent = NO;
; //				  }
; 			 }
	.dbline 148
; 		}
	xjmp L14
L13:
	.dbline 149
; 	else  {  // Check chars in rx buffer - if too many trans XOFF
	.dbline 150
; 		if((rxcnt>(UART_RX_BUFFER_SIZE-34))&&(xoffsent==NO)) {
	ldi R24,30
	lds R2,_rxcnt
	cp R24,R2
	brsh L20
X12:
	lds R2,_xoffsent
	tst R2
	brne L20
X13:
	.dbline 150
	.dbline 151
; 		    UDR0 = XOFF;
	ldi R24,19
	sts 198,R24
	.dbline 152
; 			xoffsent = YES;
	ldi R24,1
	sts _xoffsent,R24
	.dbline 153
; 			xoffcnt++;
	lds R24,_xoffcnt
	lds R25,_xoffcnt+1
	adiw R24,1
	sts _xoffcnt+1,R25
	sts _xoffcnt,R24
	.dbline 154
; 			}
	xjmp L21
L20:
	.dbline 155
; 		else if((rxcnt<5)&&(xoffsent==YES)) {
	lds R24,_rxcnt
	cpi R24,5
	brsh L22
X14:
	lds R24,_xoffsent
	cpi R24,1
	brne L22
X15:
	.dbline 155
	.dbline 156
; 		    UDR0 = XON;
	ldi R24,17
	sts 198,R24
	.dbline 157
; 			xoncnt++;
	lds R24,_xoncnt
	lds R25,_xoncnt+1
	adiw R24,1
	sts _xoncnt+1,R25
	sts _xoncnt,R24
	.dbline 158
; 			xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 159
; 		    }
	xjmp L23
L22:
	.dbline 160
; 		else UCSR0B &= ~(1<<UDRIE0); // Disable UDRE interrupt
	lds R24,193
	andi R24,223
	sts 193,R24
L23:
L21:
	.dbline 161
; 		}
L14:
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbsym r tmptail 16 c
	.dbend
	.dbfunc e TIMER0_Compare_Interrupt _TIMER0_Compare_Interrupt fV
	.even
_TIMER0_Compare_Interrupt::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R6
	st -y,R7
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R26
	st -y,R27
	st -y,R30
	st -y,R31
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 168
; }
; 
; //  Timer0 interrupts every msec - This routines decrements 
; //  countdown timers - other routines can control timing to 
; //  within 1 msec by monitoring these software timers
; void  TIMER0_Compare_Interrupt(void)
; {
	.dbline 169
;      if(ledindex==0)  {
	lds R2,_ledindex
	tst R2
	brne L25
X17:
	.dbline 169
	.dbline 170
; 	     LED_Power(LED8,OFF);
	ldi R18,1
	ldi R16,8
	ldi R17,0
	xcall _LED_Power
	.dbline 171
; 	     Set_LED_Segments(~ledchars[numstrg[0]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 172
; 	 if(decimalpoint==7) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,7
	ldi R30,0
	cpc R25,R30
	brne L27
X18:
	.dbline 172
	clr R16
	xcall _Decimal_Point
	xjmp L28
L27:
	.dbline 173
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L28:
	.dbline 174
;  	     LED_Power(LED1,ON);
	clr R18
	ldi R16,1
	ldi R17,0
	xcall _LED_Power
	.dbline 175
; 		 }
	xjmp L26
L25:
	.dbline 176
;      else if(ledindex==1)  {
	lds R24,_ledindex
	cpi R24,1
	brne L29
X19:
	.dbline 176
	.dbline 177
;  	     LED_Power(LED1,OFF);
	ldi R18,1
	ldi R16,1
	ldi R17,0
	xcall _LED_Power
	.dbline 178
; 	     Set_LED_Segments(~ledchars[numstrg[1]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+1
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 179
; 	 if(decimalpoint==6) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,6
	ldi R30,0
	cpc R25,R30
	brne L32
X20:
	.dbline 179
	clr R16
	xcall _Decimal_Point
	xjmp L33
L32:
	.dbline 180
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L33:
	.dbline 181
;  	     LED_Power(LED2,ON);
	clr R18
	ldi R16,2
	ldi R17,0
	xcall _LED_Power
	.dbline 182
; 		 }
	xjmp L30
L29:
	.dbline 183
;      else if(ledindex==2)  {
	lds R24,_ledindex
	cpi R24,2
	brne L34
X21:
	.dbline 183
	.dbline 184
;  	     LED_Power(LED2,OFF);
	ldi R18,1
	ldi R16,2
	ldi R17,0
	xcall _LED_Power
	.dbline 185
; 	     Set_LED_Segments(~ledchars[numstrg[2]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+2
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 186
; 	 if(decimalpoint==5) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,5
	ldi R30,0
	cpc R25,R30
	brne L37
X22:
	.dbline 186
	clr R16
	xcall _Decimal_Point
	xjmp L38
L37:
	.dbline 187
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L38:
	.dbline 188
;  	     LED_Power(LED3,ON);
	clr R18
	ldi R16,3
	ldi R17,0
	xcall _LED_Power
	.dbline 189
; 		 }
	xjmp L35
L34:
	.dbline 190
;      else if(ledindex==3)  {
	lds R24,_ledindex
	cpi R24,3
	brne L39
X23:
	.dbline 190
	.dbline 191
;  	     LED_Power(LED3,OFF);
	ldi R18,1
	ldi R16,3
	ldi R17,0
	xcall _LED_Power
	.dbline 192
; 	     Set_LED_Segments(~ledchars[numstrg[3]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+3
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 193
; 	 if(decimalpoint==4) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	brne L42
X24:
	.dbline 193
	clr R16
	xcall _Decimal_Point
	xjmp L43
L42:
	.dbline 194
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L43:
	.dbline 195
;  	     LED_Power(LED4,ON);
	clr R18
	ldi R16,4
	ldi R17,0
	xcall _LED_Power
	.dbline 196
; 		 }
	xjmp L40
L39:
	.dbline 197
;      else if(ledindex==4)  {
	lds R24,_ledindex
	cpi R24,4
	brne L44
X25:
	.dbline 197
	.dbline 198
;  	     LED_Power(LED4,OFF);
	ldi R18,1
	ldi R16,4
	ldi R17,0
	xcall _LED_Power
	.dbline 199
; 	     Set_LED_Segments(~ledchars[numstrg[4]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+4
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 200
; 	 if(decimalpoint==3) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	brne L47
X26:
	.dbline 200
	clr R16
	xcall _Decimal_Point
	xjmp L48
L47:
	.dbline 201
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L48:
	.dbline 202
;  	     LED_Power(LED5,ON);
	clr R18
	ldi R16,5
	ldi R17,0
	xcall _LED_Power
	.dbline 203
; 		 }
	xjmp L45
L44:
	.dbline 204
;      else if(ledindex==5)  {
	lds R24,_ledindex
	cpi R24,5
	brne L49
X27:
	.dbline 204
	.dbline 205
;  	     LED_Power(LED5,OFF);
	ldi R18,1
	ldi R16,5
	ldi R17,0
	xcall _LED_Power
	.dbline 206
; 	     Set_LED_Segments(~ledchars[numstrg[5]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+5
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 207
; 	 if(decimalpoint==2) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	brne L52
X28:
	.dbline 207
	clr R16
	xcall _Decimal_Point
	xjmp L53
L52:
	.dbline 208
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L53:
	.dbline 209
;  	     LED_Power(LED6,ON);
	clr R18
	ldi R16,6
	ldi R17,0
	xcall _LED_Power
	.dbline 210
; 		 }
	xjmp L50
L49:
	.dbline 211
;      else if(ledindex==6)  {
	lds R24,_ledindex
	cpi R24,6
	brne L54
X29:
	.dbline 211
	.dbline 212
;  	     LED_Power(LED6,OFF);
	ldi R18,1
	ldi R16,6
	ldi R17,0
	xcall _LED_Power
	.dbline 213
; 	     Set_LED_Segments(~ledchars[numstrg[6]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+6
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 214
; 	 if(decimalpoint==1) Decimal_Point(ON);
	lds R24,_decimalpoint
	lds R25,_decimalpoint+1
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L57
X30:
	.dbline 214
	clr R16
	xcall _Decimal_Point
	xjmp L58
L57:
	.dbline 215
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L58:
	.dbline 216
;  	     LED_Power(LED7,ON);
	clr R18
	ldi R16,7
	ldi R17,0
	xcall _LED_Power
	.dbline 217
; 		 }
	xjmp L55
L54:
	.dbline 218
;      else if(ledindex==7)  {
	lds R24,_ledindex
	cpi R24,7
	brne L59
X31:
	.dbline 218
	.dbline 219
;  	     LED_Power(LED7,OFF);
	ldi R18,1
	ldi R16,7
	ldi R17,0
	xcall _LED_Power
	.dbline 220
; 	     Set_LED_Segments(~ledchars[numstrg[7]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	lds R30,_numstrg+7
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 221
; 	 if(decimalpoint==0) Decimal_Point(ON);
	lds R2,_decimalpoint
	lds R3,_decimalpoint+1
	tst R2
	brne L62
	tst R3
	brne L62
X32:
	.dbline 221
	clr R16
	xcall _Decimal_Point
	xjmp L63
L62:
	.dbline 222
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L63:
	.dbline 223
;  	     LED_Power(LED8,ON);
	clr R18
	ldi R16,8
	ldi R17,0
	xcall _LED_Power
	.dbline 224
; 		 }
L59:
L55:
L50:
L45:
L40:
L35:
L30:
L26:
	.dbline 225
; 	 ledindex++;
	lds R24,_ledindex
	subi R24,255    ; addi 1
	sts _ledindex,R24
	.dbline 226
; 	 if(ledindex>7) ledindex = 0;
	ldi R24,7
	lds R2,_ledindex
	cp R24,R2
	brsh L64
X33:
	.dbline 226
	clr R2
	sts _ledindex,R2
L64:
	.dbline 228
; 
;  	 if(mseccountdown1>0)  mseccountdown1--;
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	brne X34
	tst R3
	breq L66
X34:
	.dbline 228
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
L66:
	.dbline 229
;  	 if(mseccountdown2>0)  mseccountdown2--;
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne X35
	tst R3
	breq L68
X35:
	.dbline 229
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
L68:
	.dbline 230
; 	 if(mseccountdown3>0)  mseccountdown3--;
	lds R2,_mseccountdown3
	lds R3,_mseccountdown3+1
	tst R2
	brne X36
	tst R3
	breq L70
X36:
	.dbline 230
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
L70:
	.dbline -2
L24:
	.dbline 0 ; func end
	ld R0,y+
	out 0x3f,R0
	ld R31,y+
	ld R30,y+
	ld R27,y+
	ld R26,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R7,y+
	ld R6,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	reti
	.dbend
	.dbfunc e TIMER2_Compare_Interrupt _TIMER2_Compare_Interrupt fV
	.even
_TIMER2_Compare_Interrupt::
	.dbline -1
	.dbline 236
; }
; 
; //  Real Time Clock interrupts every 4msec - This routine decrements 
; //  countdown timers and maintains the watch clock
; void  TIMER2_Compare_Interrupt(void)
; {
	.dbline 237
;  	if(rtccountdown1>0)  rtccountdown1--;
	lds R2,_rtccountdown1
	lds R3,_rtccountdown1+1
	tst R2
	brne X37
	tst R3
	breq L73
X37:
	.dbline 237
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
L73:
	.dbline 238
;  	if(rtccountdown2>0)  rtccountdown2--;
	lds R2,_rtccountdown2
	lds R3,_rtccountdown2+1
	tst R2
	brne X38
	tst R3
	breq L75
X38:
	.dbline 238
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown2+1,R25
	sts _rtccountdown2,R24
L75:
	.dbline 239
; 	if(rtccountdown3>0)  rtccountdown3--;
	lds R2,_rtccountdown3
	lds R3,_rtccountdown3+1
	tst R2
	brne X39
	tst R3
	breq L77
X39:
	.dbline 239
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown3+1,R25
	sts _rtccountdown3,R24
L77:
	.dbline 240
; 	if(rtccountdown4>0)  rtccountdown4--;
	lds R2,_rtccountdown4
	lds R3,_rtccountdown4+1
	tst R2
	brne X40
	tst R3
	breq L79
X40:
	.dbline 240
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown4+1,R25
	sts _rtccountdown4,R24
L79:
	.dbline -2
L72:
	.dbline 0 ; func end
	ret
	.dbend
; }
